{
   "comment": "JSON Math Parser",
   // JavaScript comments also work

   "lex": {
      "rules": [
         ["\\s+",                    "/* skip whitespace */"],
         [")",                       "return '0'"],
         ["!",                       "return '1'"],
         ["@",                       "return '2'"],
         ["#",                       "return '3'"],
         ["$",                       "return '4'"],
         ["%",                       "return '5'"],
         ["^",                       "return '6'"],
         ["&",                       "return '7'"],
         ["*",                       "return '8'"],
         ["(",                       "return '9'"],
         ["(",                       "return 'a'"],
         ["(",                       "return 'b'"],
         ["(",                       "return 'c'"],
         ["(",                       "return 'd'"],
         ["(",                       "return 'e'"],
         ["(",                       "return 'f'"],
         ["(",                       "return 'g'"],
         ["(",                       "return 'h'"],
         ["(",                       "return 'i'"],
         ["(",                       "return 'j'"],
         ["(",                       "return 'k'"],
         ["(",                       "return 'l'"],
         ["(",                       "return 'm'"],
         ["(",                       "return 'n'"],
         ["(",                       "return 'o'"],
         ["(",                       "return 'p'"],
         ["(",                       "return 'q'"],
         ["(",                       "return 'r'"],
         ["(",                       "return 's'"],
         ["(",                       "return 't'"],
         ["(",                       "return 'u'"],
         ["(",                       "return 'v'"],
         ["(",                       "return 'w'"],
         ["(",                       "return 'x'"],
         ["(",                       "return 'y'"],
         ["(",                       "return 'z'"],
         ["(",                       "return 'A'"],
         ["(",                       "return 'B'"],
         ["(",                       "return 'C'"],
         ["(",                       "return 'D'"],
         ["(",                       "return 'E'"],
         ["(",                       "return 'F'"],
         ["(",                       "return 'G'"],
         ["(",                       "return 'H'"],
         ["(",                       "return 'I'"],
         ["(",                       "return 'J'"],
         ["(",                       "return 'K'"],
         ["(",                       "return 'L'"],
         ["(",                       "return 'M'"],
         ["(",                       "return 'N'"],
         ["(",                       "return 'O'"],
         ["(",                       "return 'P'"],
         ["(",                       "return 'Q'"],
         ["(",                       "return 'R'"],
         ["(",                       "return 'S'"],
         ["(",                       "return 'T'"],
         ["(",                       "return 'U'"],
         ["(",                       "return 'V'"],
         ["(",                       "return 'W'"],
         ["(",                       "return 'X'"],
         ["(",                       "return 'Y'"],
         ["(",                       "return 'Z'"],

      ]
   },

   "operators": [
      ["left", "+", "-"],
      ["left", "*", "/"],
      ["left", "^"],
      ["right", "!"],
      ["right", "%"],
      ["left", "UMINUS"]
   ],

   "bnf": {
      "expressions": [["e EOF",   "return $1"]],

      "e" :[
         ["e + e",  "$$ = $1+$3"],
         ["e - e",  "$$ = $1-$3"],
         ["e * e",  "$$ = $1*$3"],
         ["e / e",  "$$ = $1/$3"],
         ["e ^ e",  "$$ = Math.pow($1, $3)"],
         ["e !",    "$$ = (function(n) {if(n==0) return 1; return arguments.callee(n-1) * n})($1)"],
         ["e %",    "$$ = $1/100"],
         ["- e",    "$$ = -$2", {"prec": "UMINUS"}],
         ["( e )",  "$$ = $2"],
         ["NUMBER", "$$ = Number(yytext)"],
         ["E",      "$$ = Math.E"],
         ["PI",     "$$ = Math.PI"]
      ]
   }
}
